(module vandusen-random-talk ()

(import chicken scheme data-structures extras)
(use vandusen srfi-18)

(plugin 'random-talk
	(lambda ()
	  (let ((count 0) (limit -1) (get-message ($ 'random-talk)))
	    (message-handler (lambda (m) 
			       (if (>= count limit)
				   (begin 
				     (thread-start!
                                      (lambda ()
                                        (thread-sleep! (random (or ($ 'random-talk-delay) 10)))
                                        (say (get-message)
                                             (list-ref ($ 'channels)
                                                       (random (length ($ 'channels)))))))
				     (set! limit (+ (or ($ 'random-talk-threshold) 10) (random 30)))
				     (set! count 0))
				   (set! count (add1 count)))
			       #f)
			     command: "PRIVMSG")))))





